#include <avr/io.h>


#define BMP180_I2C_ADR_R 				0xEF
#define BMP180_I2C_ADR_W 				0xEE

#define BMP180_ADR_CALIBRATION			0xAA //   .  
#define BMP180_CALIBRATION_SIZE 		22//   .  

#define	BMP180_REG_CONTROL 				0xF4
#define	BMP180_REG_RESULT 				0xF6//   

#define OSS 3	//
#define	BMP180_COMMAND_TEMPERATURE 		0x2E
#define	BMP180_COMMAND_PRESSURE 		(0x34+(OSS<<6))


#define	BMP180_COMMAND_SOFT_RESET 		0xF0
#define	BMP180_COMMAND_SOFT_RESET_DATA 	0xB6

#define	FL_BMP180_T_MEASURE				_BV(0)
//#define	FL_BMP180_P_MEASURE				_BV(1)
#define	FL_BMP180_NO_SENSOR				_BV(2)//     
#define	FL_BMP180_MEASURE_END			_BV(3)
#define	FL_BMP180_ERROR					_BV(4)


extern int32_t Bmp180Pressure; // 0,1 // 
extern int16_t Bmp180Temper; // 0,1 // 
extern uint16_t Rt_mm;//   
extern uint8_t FlagBMP180;

extern void measure_bmp180(void);
























//----------------------------------------------------------------
//  AVR 16   03311 011 - 0 , 033 - 1;
// AVR   LSB  MSB
//      -   MSB  LSB
/*
		// Compute floating-point polynominals:

		c3 = 160.0 * pow(2,-15) * AC3;
		c4 = pow(10,-3) * pow(2,-15) * AC4;
		b1 = pow(160,2) * pow(2,-30) * VB1;
		c5 = (pow(2,-15) / 160) * AC5;
		c6 = AC6;
		mc = (pow(2,11) / pow(160,2)) * MC;
		md = MD / 160.0;
		x0 = AC1;
		x1 = 160.0 * pow(2,-13) * AC2;
		x2 = pow(160,2) * pow(2,-25) * VB2;
		y0 = c4 * pow(2,15);
		y1 = c4 * c3;
		y2 = c4 * b1;
		p0 = (3791.0 - 8.0) / 1600.0;
		p1 = 1.0 - 7357.0 * pow(2,-20);
		p2 = 3038.0 * 100.0 * pow(2,-36);
*/
//--------------------------------------------------------------

/*
After  start  condition  the  master  sends  the  device  address  write,  the  register 
address  and  the  control  register  data.  The  BMP180  sends  an  acknowledgement  (ACKS)  every  8 
data bits when data is received. The master sends a stop condition after the last ACKS.
S start
0xEE address  write (ask  BMP)
0xF4 register address (ask  BMP)
 control  register  data (ask  BMP)
 0x2E - Temperature    4.5 ms
 0x34 - Pressure (oss = 0)  4.5ms
 0x74 - Pressure (oss = 1)  7.5ms
 0xB4 - Pressure (oss = 2)  13.5ms
 0xF4 - Pressure (oss = 3)  25.5ms
P stop
*/

/*
Read A/D conversion result or EPROM data.
After the start condition the master sends the module address write command and register address. 
The register address selects the read register:
EPROM data registers       0xAA to 0xBF
Temperature or pressure value UT or UP   0xF6 (MSB), 0xF7 (LSB), optionally 0xF8 (XLSB).

S
0xEE cmd address+write (ask  BMP)
0xF6 address out_msb (ask  BMP)
S
0xEF cmd address+read (ask  BMP)
read msb  -> ask
read lsb   -> nask
P

Then  the  master  sends  a  restart  condition  followed  by  the  module  address  read  that  will  be 
acknowledged by the BMP180 (ACKS). The BMP180 sends first the 8 MSB, acknowledged by the 
master (ACKM), then the 8 LSB. The master sends a "not acknowledge" (NACKM) and finally a stop 
condition. 
Optionally for ultra high resolution, the XLSB register with address 0xF8 can be read to extend the 
16 bit word to up to 19 bits; refer to the application programming interface (API) software rev. 1.1 
(BMP180_ API, available from Bosch Sensortec).




1    = 133,322 /^2  133 .  ,      760   , 
    : 760*133,322 = 101325    101 .
 
 =  * 101325 / 760,
:
       ( . ., mm Hg, ., torr)
     (, ).

=*760/101325

: http://www.kakprosto.ru/kak-14335-kak-perevesti-millimetry-rtutnogo-stolba-v-paskali#ixzz3wr7f2LZ5

*/
