#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>

#include "pin_macros.h"
#include "cl_id10.h"
//#include "sht10.h"
#include "font.h"
#include "reg_id10.h"

#include "bmp180.h"
#include "sht21.h" 
#include "i2cSoft.h"
//2016

// 
static uint16_t usr_pressure(uint16_t *m, uint8_t usr);

//**************************************
ISR(SIG_OVERFLOW0){
	if (++lcd_time_switch==light_isr)
		OFF(STORAGE);//    Z    PORTLCD=lcd_buffer[znakomesto];
}
//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)
	{	   	 		  	   	  				   	
	clock_=correct;
	isr_1sek_=1;
  	}
}

//--------------------------------------
static void port_init(void)
{
	DRIVER(DATA_595,OUT);
	DRIVER(SHIFT,OUT);
	DRIVER(STORAGE,OUT);
	
	DRIVER(CALLS_OSN,OUT);
	DRIVER(CALLS_NAGRUZ,OUT);
	DRIVER(TIMER_PIN,OUT);
	
	DRIVER(EXT_POWER,PULLUP);
//	DRIVER(SCK,OUT);
	
	DRIVER(KL_F,PULLUP);
	DRIVER(KL_SET,PULLUP);
	DRIVER(KL_PLUS,PULLUP);
	DRIVER(KL_MINUS,PULLUP);
}
//**************************************
static void timer0_init(void){
	TCCR0B=0x01;
}
//**************************************
static void timer2_init(void)
{
	TCCR2B = 0x00;		//stop
	ASSR  = (1<<AS2);	//set async mode
	TCCR2B = 0x01;		//start
}
//**************************************
void timer1_init(void)
{
	TCCR1B = 0; //stop
	TCCR1A	= 0;
	OCR1AH = setup.ocr1[OCR1AHI];
	OCR1AL = setup.ocr1[OCR1ALOW];
	DDR_OC1A  &=~ OC1A;	  //OC1A 
}
//**************************************
void timer1_init_in_pwm(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
}
//**************************************	
void shim_true(void){
	timer1_init_in_pwm();
	TCCR1B=(1<<CS10)|(1<<WGM12);
}
//**************************************

void init_devices(void)
{
	cli(); //disable all interrupts
	CLKPR=_BV(CLKPCE);
	CLKPR=0;
	port_init();
	timer0_init();
	timer1_init();
	//MCUCR = 0x00;
	SMCR = 0x00;
// GICR  = 0x00;
	ACSR=_BV(ACD);
	TIMSK2=(1<<TOIE2);
	TIMSK0=(1<<TOIE0);
	sei(); //re-enable interrupts
}

// ***********************************************************
//void clear_adres_eeprom(void)
//{
// 	EEARH=0x01;
//	EEARL=0xFF;
//}
//**************************************
//   
/*static inline unsigned char EEPROM_READ(unsigned int uiAddress)
{
	//     
	while(EECR & (1<<EEWE));
	//   
	EEAR = uiAddress;
	//       EERE 
	EECR |= (1<<EERE);
	//      
	return EEDR;
}

static void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		//     
		while(EECR & (1<<EEWE));
		cli();
		//     
		EEAR = uiAddress;
		EEDR = ucData;
		//  . 1   EEMWE 
		EECR |= (1<<EEMWE);
		//       EEWE 
		EECR |= (1<<EEWE);
		sei();
		}
	//clear_adres_eeprom();
}*/
//-----------------------------EEPROM---------------------------------------
static unsigned char EEPROM_READ(unsigned int uiAddress)
{
	while(EECR & (1<<EEPE));//     
	EEAR = uiAddress;//    
	EECR |= (1<<EERE);//       EERE 
	return EEDR;//      
}
static void EEPROM_write(unsigned char uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		while(EECR & (1<<EEPE));//     
		EEAR = uiAddress;
		EEDR = ucData;
		cli();
		EECR |= (1<<EEMPE);
		EECR |= (1<<EEPE);
		sei();
		}
}
//*********************************************
void light_init(void){
	setup.day_light	=7;
	setup.night_light	=3;
	setup.tim_c_light	=23;
	setup.tim_do_light	=6;
}

static void read_data_EEPROM(void)
{
unsigned char  *a, i;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=0 ; i<sizeof(setup); i++, a++){
		*a=EEPROM_READ(i);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) {
		eeprom_err=1;
		}
	if ( setup.day_light>sizeof(light_disp) ) light_init();
}

void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p;
 
	//if (time_flag & fl_eeprom_write)
	{
	//time_flag&= ~fl_eeprom_write;
	setup.crc=eeprom_err=0;
	ON(STORAGE);
	//TIMSK0 &=~(1<<TOIE0);//   ""   
//	PORTLCD=0;
	p=(unsigned char *) &setup;
	for(i=0; i<sizeof(setup) ; i++, p++){
		EEPROM_write( i, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
	}
}
//*********************************************


//*************** 1 Wire DALLAS ************************************************

void pullup_off(void){
	DDR_1wire&=~PWIRE0;
	DDR_1wire&=~PWIRE1;
	PORT_1wire&=~PWIRE0;
	PORT_1wire&=~PWIRE1;
}
//***********************************************
unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

//	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);//11
	i=PIN_1wire;
	sei();
	_delay_us(47);//47
	return i;
}
//***********************************************
void readbyte(uint8_t *pw) {  
unsigned char read_byte[2]={0,0};//,i, r,  pinwire;

pullup_off();
for(uint8_t i=0, r=1; i<8; i++){
	uint8_t pinwire=readbit();
	if ( pinwire & PWIRE0 ) read_byte[0]|=r;
	if ( pinwire & PWIRE1 ) read_byte[1]|=r;
	r<<=1;
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
pw[0]=read_byte[0];	
pw[1]=read_byte[1];
}
//----------------------------------------------
void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
static void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(58);
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
pullup_off();
	for(i=0; i<8; i++){
		if (byte&_BV(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
}

//****************************************

void detectPresence(void){
unsigned char i;

	pullup_off();
	out_1wire=PWIRE0|PWIRE1;
	
	DDR_1wire|=PWIRE0;
	DDR_1wire|=PWIRE1;
	
	_delay_ms(0.48);
	DDR_1wire&=~PWIRE0;
	DDR_1wire&=~PWIRE1;
	
	cli();
	_delay_us(60);
	i=PIN_1wire;
	sei();
	
	if ( i & PWIRE0 ) out_1wire&=~PWIRE0;
	if ( i & PWIRE1 ) out_1wire&=~PWIRE1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & PWIRE0 )) out_1wire&=~PWIRE0;
	if (!( i & PWIRE1 )) out_1wire&=~PWIRE1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
static void scratchpad_save(void){

		detectPresence();//  
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(5);//	TH
		writebyte(5);//	TL
		writebyte(0x7f);//	Statys 12bit
		
		detectPresence();//   EEPROM
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x48);//COPY SCRATCHPAD [48h]
		
		PORT_1wire|=power_suplly_1w;
		DDR_1wire|=power_suplly_1w;
}
//****************************************
void izmerenie_t(void){

if (!regim)//       
	{
	if ( !count_com_1w ){//
		count_com_1w++;
		detectPresence();//  
		return;
		}

	if ( count_com_1w == 1 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
		pullup_off();
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//PWIRE0|PWIRE1;
		if  (power_suplly_1w) time_1w_flag|=FL_PARASITE_POWER;
			else time_1w_flag&=~FL_PARASITE_POWER;
		PORT_1wire|=power_suplly_1w;
		DDR_1wire|=power_suplly_1w;
		return;
		}

	if ( count_com_1w == 2 ){	// 
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		//time[WIRE1]=127;//1sek
		TimeMeasureDs18B20=5;//3sek
		return;
		}

	if ( count_com_1w == 4 ){
		//if (time[WIRE1]<-15) count_com_1w++;
		if (TimeMeasureDs18B20<0) count_com_1w++;
		
		return;
		}

	if ( count_com_1w == 5 ){// 
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		return;
		}

	if ( count_com_1w == 7 ){
		count_com_1w=0;
		readbyte(tempir_lsb);// 
		readbyte(tempir_msb);
		}

	}
}
//***********************************************/
//*************** END 1 Wire ***************************************************


static void change_light_var(void)
{
		if ( time_flag & FL_PLUS )
		   {
		   if (++change_light>=lcd_light) time_flag &= ~FL_PLUS;//    
		   }
		   else
		   {
		   if (change_light>1) change_light--; else time_flag|= FL_PLUS;//  
		   }
}
//**************************************
static uint8_t opred_light_current_num(void)
{
  char l;
  unsigned int a=0x100;
 	
	l=lcd_light;
	if (mask)
	 	{
		a>>=znakomesto;
		if ( mask&a ) l=change_light;
		}
		else	
		{
		time_flag &= ~FL_PLUS;
		change_light=lcd_light;
		}
	return l;
}

//*************************************************************
static void data_shift(unsigned char data)
{
//   ,    8 . 
	for(uint8_t i=8; i ; i--){  
		if (data & _BV(7) )		ON(DATA_595);	//   
						else	OFF(DATA_595); 
		//asm("nop");
		ON(SHIFT); //  
		data<<=1;
		OFF(SHIFT);
		}	 
}
//*************************************************************
static void num_out(void)
{
	ON(STORAGE);//    Z 
	
	data_shift(lcd_buffer[znakomesto]);//       
 	data_shift(~(1<<(znakomesto)));//  ,      ~(1<<(znmesto)) -     ( 03->0b11110111)
 
	OFF(STORAGE); 
	ON(STORAGE);	// 
	//OFF(STORAGE);	//   

	if (znakomesto==7){// 7  
		ON(SHIFT);//shift    0   Q6  -Q7`
		asm("nop");
		OFF(SHIFT);
		}											
	if (znakomesto==8)   data_shift(0);//9 . 
	//       1, 
	//     -Q7 = 0,   . 
	
	OFF(DATA_595);
	OFF(SHIFT);  
}
//*************************************************************

static void button_signal(void){
if ( ( setup.ocr1[OCR1AHI_BUT] )||( setup.ocr1[OCR1ALOW_BUT] ) ){
	OCR1AH  = setup.ocr1[OCR1AHI_BUT];//0x04;
	OCR1AL  = setup.ocr1[OCR1ALOW_BUT];//0x00;
	shim_true();//
	time_flag|=FL_SIG_BUTT;
	time[NOTE_BUT]=7;
	}
}

/*static void str_initread_port(void){
	DDRLCD =0xF0;
	PORTLCD=0x0F;
	_delay_us(15);
}*/

//**************************************
void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;
		
	if 		( ACTIVE(KL_F) )		key_lokal=1;
	else if ( ACTIVE(KL_SET) )		key_lokal=2;
	else if ( ACTIVE(KL_PLUS) )		key_lokal=3;
	else if ( ACTIVE(KL_MINUS) )	key_lokal=4;

	if ( key_lokal!=17 )
	{
	anti_drebezg[0]++;
		if (anti_drebezg[0]==35)//35)
		{
		key=key_lokal;
		button_signal();
		}
		if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
	   	   anti_drebezg[0]=0;					//anti_drebezg[1] -   
		   anti_drebezg[1]++;					//anti_drebezg[2]    
		   if (anti_drebezg[1]<=20){
				if (++anti_drebezg[1]==2) anti_drebezg[2]=120;//55;
				if (  anti_drebezg[1]==4) anti_drebezg[2]=80;//55;
				if (  anti_drebezg[1]==6) anti_drebezg[2]=55;//55;
				if (  anti_drebezg[1]==8) anti_drebezg[2]=45;//55;
				if (  anti_drebezg[1]>=20) anti_drebezg[2]=35;//55;
				}
		   }	
	time_in_regim=25;
	}
	else
	{
	anti_drebezg[0]=0;
	anti_drebezg[1]=0;
	anti_drebezg[2]=200;
	}
     
}

//**************************************
void inc_dec_var_bit(unsigned char *var,unsigned char bit_n){
	if (PLUS)	 (*var)|= _BV(bit_n);
	if (MINUS) 	 (*var)&=~_BV(bit_n);
}

//**************************************
void inc_dec_var(unsigned char *var, unsigned char limit){
	if (PLUS){
		if ((*var)<limit)	(*var)++; 
		else *var=0;
		}
	if (MINUS){
		if (*var) (*var)--;
		else *var=limit;
		}
}
//**************************************
void mask_next_regim(unsigned int m, unsigned char next_F,unsigned char SET)
{
 	if (!anti_drebezg[0])  mask=m; 
	if (F_)   regim=next_F;
	if (SET_) regim=SET;
	key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<END_REGIM) 
		regim++;
		} 
	if (MINUS) {
		if (regim>FIRST_REGIM)
		regim--;
		} 
}

void reg_see_init(void){
	current_state_view.regim=0;
	current_state_view.time=3;
}

//**************************************
static void key_action(void)
{//mask_next_regim( maska regima, if (key F_), if (key SET_) )

	mask=0;

	if (key!=17){
		if (!( (regim>=reg_signal+1)&&(regim<=reg_signal+2) ))
		if ( signal ){ 
			time_flag|= FL_SIGNAL_CLS;
			time_flag&=~FL_SIGNAL_OUT_ENABLE;
			if (F_) time_flag&= ~FL_SIG_OTSR;//        ,  
			regim=0;
			return;
			}
		}	

	if (!regim) {
		if (F_) {
			regim=REG_BUDILNIK;
			}
			else
		if (SET_){//    ?
		   regim=100;
		   }
		   else
		if (MINUS) regim=31;
			else
		if (PLUS) {
			regim=91;
			reg_see_init();
			}
		return;
		}
	
	if (regim==REG_BUDILNIK)	{ mask_next_regim(0xFFFF,REG_TIMER,31); return;}//calls	
	if (regim==REG_TIMER) 		{ mask_next_regim(0xFFFF,REG_SETUP,3); return;}//timer
	if (regim==REG_SETUP) 		{ mask_next_regim(0xFFFF,0,FIRST_REGIM);  return;}//setup

	if (regim==100) {//  set      100
		if ( (MINUS)||(PLUS) ) {
			time_flag&= ~FL_SIG_OTSR;//    
			regim=0;
			}
		mask_next_regim(0,0,0);
		return;
		}
	
	//___________________timer____________________
	if (regim==3) {
		mask_next_regim(0,0,80);//t00-00-00
		return;
		}
	if (regim==80) { //true chet timer
		if (key!=17) time_flag|= FL_SIGNAL_CLS;//    
	 	inc_dec_var_bit(&timer[3], FL_TIMER_COUNT);
		if (PLUS) {
			regim=3;
			TimerTime[H_SEK]=timer[H_SEK];
			TimerTime[H_MIN]=timer[H_MIN];
			TimerTime[H_HOUR]=timer[H_HOUR];
			}
		mask_next_regim(0b100000000,3,81);
		return;
	 	}
	if (regim==81) {//set hour timer
	 	inc_dec_var(&timer[H_HOUR],99);
	 	mask_next_regim(0b11000000,3,82);
		return;
		}
	if (regim==82) {//set min timer
	 	inc_dec_var(&timer[H_MIN],59);
	 	mask_next_regim(0b11000,3,83);
		return;
		}
	if (regim==83) {//set sek timer
	 	inc_dec_var(&timer[H_SEK],59);
	 	mask_next_regim(0b11,3,80);
		return;
		}	
	//----------------------------------------------
	 //CALLS//****************************
	 if (regim==31) {//set number calss
	 	inc_dec_var(&budilnik_nomer,11);
	 	mask_next_regim(0b100000000,0,32);
		p_index=0;
		return;
	 	}
	 if (regim==32) {//on off calls

	 	if (( budilnik_nomer >= 8 )&&( budilnik_nomer <= 9 )){
			if (p_index) 
				{
				inc_dec_var(&nedelia[budilnik_nomer-8],1);
				mask_next_regim(0b100000,31,33);
				return;
				}
			if (SET_) { p_index=1; return; }
			}
	
		if (MINUS)
			setup.budilnik[ budilnik_nomer ][C_SIG]=0;
			
		if (PLUS)
		if ( ++setup.budilnik[ budilnik_nomer ][C_SIG] > 4 ) 
				setup.budilnik[ budilnik_nomer ][C_SIG]=0;	
		
		if ( budilnik_nomer > 9 ) 
			if ( setup.budilnik[ budilnik_nomer ][C_SIG] > 0 ) 
				setup.budilnik[ budilnik_nomer ][C_SIG]=2;
		
	 	mask_next_regim(0b11000000,31,33);
		return;
	 	}
	 if (regim==33) {//set hour calss
	 	inc_dec_var(&setup.budilnik[budilnik_nomer][C_HOUR],23);
	 	mask_next_regim(0b11000,31,34);
		return;
	 	}
	 if (regim==34) {//set min calls
	 	inc_dec_var(&setup.budilnik[budilnik_nomer][C_MIN],59);
		uint8_t a;
		if (budilnik_nomer<10) a=35; else a=45;
	 	mask_next_regim(0b11,31,a);
		return;// 
	 	}
	if  ( (regim>34)&&(regim<42) )
	for( uint8_t i=35,a=0; i<42 ;i++,a++){
	  if (regim==i) {//set day calss
			inc_dec_var_bit( &setup.budilnik[budilnik_nomer][H_DAY], a );
			mask_next_regim(_BV(6-a),31,i+1);
			break;
			}
		}
	if (regim==42) {//save current budilnik in eeprom
		//EEPROM_save_parametr_all();
		regim=31;
		return;
		}
	if (regim==45) {//set hour
		inc_dec_var(&setup.budil_pin[budilnik_nomer-10][H_HOUR],17); 
		mask_next_regim(0b11000000,31,46);
		return;
	 	}
	if (regim==46) {// set min
	 	inc_dec_var(&setup.budil_pin[budilnik_nomer-10][H_MIN],59);
		mask_next_regim(0b11000,31,47);//
		return;
	 	}
	if (regim==47) {// set min
	 	inc_dec_var(&setup.budil_pin[budilnik_nomer-10][H_SEK],59);
		mask_next_regim(0b11,31,35);//
		return;
	 	}
	//************ end calls *****************	

	//-----------------PORT------------------1//120
	 if (regim==REG_PORT) {//120
		next_regim();
		mask_next_regim(0xFFFF,0,71);//Port  C	
		return;
		}
	 if (regim==71) {//_pin-0_ _c								   //A_0 E_0 C
	 	if (PLUS) ON(CALLS_NAGRUZ);
		if (MINUS) OFF(CALLS_NAGRUZ);
		mask_next_regim(0b1000,REG_PORT,REG_PORT);
		return;
		}
	//--------------------END PORT-----------------

	//====================CLOCK====================2//121
	 if (regim==REG_CLOCK) {//121
		next_regim();
		mask_next_regim(0xFFFF,0,r_clock); 
		return; 
		}//clock 
		
	// 12-00-00
	if (regim==r_clock) {//set  sek
	 	if (MINUS){
		   if (hour[H_SEK]>31) hour[H_MIN]++;
		   hour[H_SEK]=0;
		   clock_=0;
		   }
	 	mask_next_regim(0b11,REG_CLOCK,r_clock+1);
		return;
		}	

 	if (regim==r_clock+1) {//set min
	 	inc_dec_var(&hour[H_MIN],59);
	 	mask_next_regim(0b11000,REG_CLOCK,r_clock+2);
		return;
		}
	if (regim==r_clock+2) {//set hour
		//time_light_global();
	 	inc_dec_var(&hour[H_HOUR],23);
	 	mask_next_regim(0b11000000,REG_CLOCK,r_clock+3);
		return;
		}
	
	// 28.07.08 
	if (regim==r_clock+3) {//set num 
	 	inc_dec_var(&hour[H_NUM],30);
	 	mask_next_regim(0x0180,REG_CLOCK,r_clock+4);
		return;
		}
	if (regim==r_clock+4) {// set month 
	 	inc_dec_var(&hour[H_MONTH],11);
	 	mask_next_regim(0b1100000,REG_CLOCK,r_clock+5);
		return;
		}
	if (regim==r_clock+5) {// set  year
	 	inc_dec_var(&hour[H_YEAR],99);
	 	mask_next_regim(0b11000,REG_CLOCK,r_clock+6);
		return;
		}
	if (regim==r_clock+6) {//set day
	 	inc_dec_var(&hour[H_DAY],7-1);
	 	mask_next_regim(0b11,REG_CLOCK,r_clock+7);
		return;
		}

	//  corection
	if (regim==r_clock+7) {//set corection znak
	 	inc_dec_var_bit(&setup.corr_flag, FL_CORR_ZNAK_PL);
	 	mask_next_regim(0x10,REG_CLOCK,r_clock+8);
		return;
		}
	 if (regim==r_clock+8) {//set corection
	 	inc_dec_var(&setup.correction,sizeof(corr_in_lcd)/2-1);
	 	mask_next_regim(0x0F,REG_CLOCK,REG_CLOCK);
		//if (regim==REG_CLOCK) {
		//	EEPROM_save_parametr_all();
		//	}
		return;
		}
	//-----------------end cklock-----------------------
	
	//SEE//*****************************
	if (regim==REG_YST_SEE){
		reg_see_init();
		next_regim();
		mask_next_regim(0xFFFF,0,91);//_t_SEE_
		return;
		}
	if (regim==91) {//F1 r.1-000 1 F0..0 00
	 	inc_dec_var( &current_state_view.regim, Count_regim-1);
	 	mask_next_regim(0b100000000,REG_YST_SEE,92);//_BV(8)
		return;
		}	
	if (regim==92) {//F1 r.1-000 
	 	inc_dec_var(&setup.state_regim[current_state_view.regim],num_formats);
	 	//mask_next_regim(0b1000000,91,93);
	 	mask_next_regim(0xFFFF,91,93);
		return;
		}	
	if (regim==93) {//r.1-000 F1
	 	inc_dec_var(&setup.state_time[current_state_view.regim],99);
	 	mask_next_regim(0b1100,91,94);
		//if (regim==91) EEPROM_save_parametr_all();
		return;
		}
	if (regim==94) {//F1 r.1-000 
	 	inc_dec_var(&setup.state_skip[current_state_view.regim],9);
	 	mask_next_regim(0b1,91,91);
		return;
		}
	
	//-------------END SEE----------------
	
	//-------------yct bud----------------
	if (regim==REG_YST_BUD) {//123
		next_regim();
		mask_next_regim(0xFFFF,0,75);//yct bud	
		return;
		}
	if (regim==75) {//CAL. bIP C
	 	inc_dec_var(&setup.signal_bud, 2);
		mask_next_regim(0x07,REG_YST_BUD,REG_YST_BUD);
		//if (regim==REG_YST_BUD) EEPROM_save_parametr_all();
		return;
		}
	//-------------------end___yct bud--------------------

	//-------------------light--------------------------//
	if (regim==REG_LIGHT) {//125
		next_regim();
		mask_next_regim(0xFFFF,0,11); 
		return; 
		}
	if (regim==11) {
	 	inc_dec_var(&setup.day_light,sizeof(light_disp)-1);
		//if (!setup.day_light) setup.day_light=1;
	 	mask_next_regim(0b10,REG_LIGHT,14);
		return;
		}
	if (regim==14) {
	 	inc_dec_var(&setup.night_light,sizeof(light_disp)-1);
		//if (!setup.night_light) setup.night_light=1;
	 	mask_next_regim(0b10,REG_LIGHT,15);//noch L.5
		return;
		}
	if (regim==15) {
		inc_dec_var(&setup.tim_c_light,23);
		mask_next_regim(0b1100000,REG_LIGHT,16);
		return;
		}
	if (regim==16) {
		inc_dec_var(&setup.tim_do_light,23);
		mask_next_regim(0b11,REG_LIGHT,REG_LIGHT);
		//if (regim==REG_LIGHT) EEPROM_save_parametr_all();
		return;
		}
	//---------------end__light--------------------
	
	//------------SIGHAL---------------------------
	if (regim==REG_SIGNAL){//124
		next_regim();
		mask_next_regim(0xFFFF,0,reg_signal);//SIGHAL
		return;
		}
	if (regim==reg_signal){
		inc_dec_var(&p_index,1);
		mask_next_regim(0b011111100,REG_SIGNAL,reg_signal+1);//budil button 
		time[NOTE]=3;
		time_flag|= FL_SIGNAL_CLS;
		//if (regim==REG_SIGNAL) EEPROM_save_parametr_all();
		return;
		}
	if (regim==reg_signal+1) {//H000 L000
	 	inc_dec_var(&setup.ocr1[p_index*2],0xFF);//OCR1AHI
	 	mask_next_regim(0b011100000,reg_signal,reg_signal+2);
		return;
		}
	if (regim==reg_signal+2) {//H000 L000 
	 	inc_dec_var(&setup.ocr1[p_index*2+1],0xFF);//ocr1alo
	 	mask_next_regim(0b000000111,reg_signal,reg_signal+1);
		return;
		}
	//-------------end__signal--------------

	//-------------ds18b20------------------
	if (regim==REG_DS18B20) {//126
		next_regim();
		mask_next_regim(0xFFFF,0,111);
		return; 
		}//ds18b20	
	if (regim==111) {
		inc_dec_var(&setup.vid_t,1);//OCR1AHI
		mask_next_regim(0x20,REG_DS18B20,112); 
		p_index=0;
		return;
		}
	if (regim==112) {
		inc_dec_var(&p_index,1);//OCR1AHI
		mask_next_regim(_BV(4),REG_DS18B20,113); //cor1 00.0
		return;
		}	
	if (regim==113) {
		if (PLUS) {
			if (setup.corrDs[p_index]<30) setup.corrDs[p_index]++; else  setup.corrDs[p_index]=30;
			}
		if (MINUS){
			if (setup.corrDs[p_index]>-30) setup.corrDs[p_index]--; else  setup.corrDs[p_index]=-30;
			}
		
		mask_next_regim(0x0F,112,114); //cor1 00.0
		return;
		}	
	if (regim==114) {
		mask_next_regim(0,REG_DS18B20,REG_DS18B20); 
		if (regim==REG_DS18B20) {
//			PORTLCD=0;
			scratchpad_save();		 
			//regim=REG_DS18B20;
			}
		return;
		}
	//-----------end=ds18b20----------------

	//-------------BMP180------------------
	if (regim==REG_BMP180) {//Pressure
		next_regim();
		mask_next_regim(0xFFFF,0,120);
		return; 
		}
	if (regim==120) {
		mask_next_regim(0xFFFF,REG_BMP180,121); 
		return;
		}
	if (regim==121) {
		uint16_t Pr;
		Pr=usr_pressure(pressure_massiv_min,USR_PRESS_MIN_TIME);
		for(uint8_t i=0; i<sizeof(pressure_massiv_max)/sizeof(uint16_t); i++){
			pressure_massiv_max[i]=Pr;
			}
		regim=REG_BMP180;
		return;
		}
	//-----------end=BMP180----------------
	
	//----------- ----------------
	if (regim==REG_SAVE_SETUP) {
	 	if (SET_){
			EEPROM_save_parametr_all();
			regim=0;
			}
			
		next_regim();
	 	mask_next_regim(0b111111111,0,0);
		return;
		}
	
	//----------------------------------
	if (regim==REG_SBROS_N) {
	 	if (SET_){
			uint8_t *p;
		   	p=(unsigned char *) &setup;
			for( uint8_t i=0; i<sizeof(setup) ; i++, p++)
				*p=0;
			light_init();
			setup.ocr1[OCR1AHI_BUT]=0x04;
			setup.ocr1[OCR1ALOW_BUT]=0x00;
			setup.ocr1[OCR1AHI]= 0x02;
			setup.ocr1[OCR1ALOW]=0x00;
			change_light=5;
			EEPROM_save_parametr_all();
			regim=0;
			}
			
		next_regim();
	 	mask_next_regim(0b111111111,0,0);
		return;
		}
	 //_______________________________________________
}

//**************************************
void result_in_bcd(int result)
{
    unsigned char dig_out=0;
	bcd_num0=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
static void cls_lcd_buffer(void){
unsigned char i;
 for(i=0;i<9;i++){
	lcd_buffer[i]=0;
	//lcd_buffer[i]=0xFF;
	}
}
//**************************************

//**************************************
void load_str_in_lcdbuffer1(prog_int8_t* str_lcd){
unsigned char b,e,length;//str_lcd[0] = 0000 1111-, 1111 0000 -  
	length=pgm_read_byte_near(&str_lcd[0]);
	for( b=0x0F&(length), e=1 ; b<(0x0F&(length>>4)) ; b++, e++){
		lcd_buffer[b]=pgm_read_byte_near(&str_lcd[e]);
		}
}
//**************************************
void num2_bcd_in_lcd(unsigned char znak_mesto, unsigned char param_out)
{
 	result_in_bcd(param_out);
	lcd_buffer[znak_mesto]=font[bcd_num3];
	lcd_buffer[znak_mesto+1]  =font[bcd_num4];
}
//**************************************
void blank_nul(unsigned char mesto){
 if (lcd_buffer[mesto]==font[n0]) 
	lcd_buffer[mesto]=0;
}

//**************************************
void clock_in_lcd_gl(unsigned char znakomesto)
{
 	num2_bcd_in_lcd(znakomesto,hour[H_HOUR]);
	blank_nul(znakomesto);
	#ifdef miganie
 	if ( time_flag & FL_SEK_1_SWITCH )
	#endif
	lcd_buffer[znakomesto+2]=font[f_seg_g];
	num2_bcd_in_lcd(znakomesto+3,hour[H_MIN]);
}
//**************************************
void clock_in_lcd0(void)
{
 	num2_bcd_in_lcd(0,hour[H_NUM]+1);
	lcd_buffer[1]|=font[tochka];
	result_in_bcd(hour[H_DAY]+1);
	lcd_buffer[2]=font[bcd_num4];
	clock_in_lcd_gl(4);
}
//**************************************
void day_str(void){
	lcd_buffer[7]=h_day_str[hour[H_DAY]*2];
	lcd_buffer[8]=h_day_str[hour[H_DAY]*2+1];
}
//**************************************
static void clock_day_str(void){
	clock_in_lcd_gl(1);
	day_str();
}
//**************************************
void lcd_hh_mm(unsigned char *param){
	num2_bcd_in_lcd(4,*param);
	lcd_buffer[6]=font[f_seg_g];
	num2_bcd_in_lcd(7,*(param-1));
}
//**************************************
static void num_month_day(void){//iln
	num2_bcd_in_lcd(1, hour[H_NUM]+1);
	lcd_buffer[3]=font[f_seg_d];
	num2_bcd_in_lcd(4, hour[H_MONTH]+1);
	lcd_buffer[6]=font[f_seg_d];
	day_str();
}
//**************************************

//**************************************
void form_str(int s, uint8_t mesto, uint8_t point, uint8_t ErrorDatchick){
unsigned char znak=0, n1=0,n2=0;	
	
	//if (time_1w_flag & FL_SHT10_ERR){
	if (ErrorDatchick){
		lcd_buffer[mesto]=font[f_seg_g];
		lcd_buffer[mesto+1]=font[f_seg_g];
		lcd_buffer[mesto+2]=font[f_seg_g];
		return;
		}
		
	if ( s<0 ){
		s*=-1;
		znak=1;
		}
		
	result_in_bcd(s);// 15.7 104.3 -55.2 5.2 -5.3
		
	if (setup.vid_t==0)
		{
			if ( bcd_num1 ) n1=font[bcd_num1];
			else 
			if (znak) 	n1=font[f_seg_g];
			n2=font[bcd_num2];
		} 
		else
		{
			if ( bcd_num1 ) {
			n1=font[bcd_num1];
			n2=font[bcd_num2];
			}
			else
			{
			if ( bcd_num2 ){ 
			n2=font[bcd_num2]; 
			if ( znak ) n1=font[f_seg_g];
			}
			else
			if ( znak ) n2=font[f_seg_g];
			}
		}
		
	lcd_buffer[mesto]=n1;
	lcd_buffer[mesto+1]=n2;
	lcd_buffer[mesto+2]=font[bcd_num3];
	
		
	if (point) {
		lcd_buffer[mesto+2]|=font[tochka];
		lcd_buffer[mesto+3]=font[bcd_num4];
		}
		else if (bcd_num4>5) lcd_buffer[mesto+2]|=font[tochka];
}
void tempir_in_bcd(uint8_t t, uint8_t mesto, uint8_t pin_wire, uint8_t point){
//unsigned char znak=0;//, n1=0,n2=0;

/*	if ( !(pin_wire & out_1wire) ){
	 	lcd_buffer[mesto]	=font[f_seg_g];
		lcd_buffer[mesto+1]	=font[f_seg_g];
		lcd_buffer[mesto+2]	=font[f_seg_g];
		}
		else */
		{

		int16_t te;
		te=((unsigned int)(tempir_msb[t]<<8))|tempir_lsb[t];//msb
		te=((te*10)>>4)+setup.corrDs[t];

		form_str(te, mesto,point, (!(pin_wire & out_1wire)) );
		/*result_in_bcd(te);// 15.7 104.3 -55.2 5.2 -5.3
		
		if (setup.vid_t==0)
		{
			if ( bcd_num1 ) n1=font[bcd_num1];
			else 
			if (znak) 	n1=font[f_seg_g];
			n2=font[bcd_num2];
		} 
		else
		{
			if ( bcd_num1 ) {
			n1=font[bcd_num1];
			n2=font[bcd_num2];
			}
			else
			{
			if ( bcd_num2 ){ 
			n2=font[bcd_num2]; 
			if ( znak ) n1=font[f_seg_g];
			}
			else
			if ( znak ) n2=font[f_seg_g];
			}
		}
		
		lcd_buffer[mesto]=n1;
		lcd_buffer[mesto+1]=n2;
		lcd_buffer[mesto+2]=font[bcd_num3];
		lcd_buffer[mesto+3]=font[bcd_num4];
		
		if (point) lcd_buffer[mesto+2]|=font[tochka];
			else if (bcd_num4>5) lcd_buffer[mesto+2]|=font[tochka];*/
		}
}


//**************************************
void tempir__clock_in_lcd(void){
	lcd_buffer[3]=font[f_gr];
	clock_in_lcd_gl(4);
}
static void tempir_1_clock_in_lcd(void){
	tempir_in_bcd(DS0,0, PWIRE0, false );
	tempir__clock_in_lcd();
}
static void tempir_2_clock_in_lcd(void){
	tempir_in_bcd(DS1,0,PWIRE1, false);
	tempir__clock_in_lcd();
}
//**************************************/
void tempir_2_in_lcd(unsigned char point){
	tempir_in_bcd(DS0,0,PWIRE0, point);
	tempir_in_bcd(DS1,5,PWIRE1, point);
}
//**************************************/
static void tempir_2o_in_lcd(void){//temp o temp
	tempir_2_in_lcd(true);
	lcd_buffer[4]=font[f_gr];
}

static void tempir_2oo_in_lcd(void){//temp o temp
	tempir_2_in_lcd(false);
	lcd_buffer[3]=font[f_gr];
	lcd_buffer[8]=font[f_gr];
}
//**************************************/
void grad_celsia(void){
	lcd_buffer[7]=font[f_gr];
	lcd_buffer[8]=font[f_C];
}
//**************************************/
static void one_tempir_0_in_lsd(void){
	tempir_in_bcd(DS0,2,PWIRE0,true);//012345678 //inl
	grad_celsia();
	lcd_buffer[0]=font[f_d]|font[tochka];
}
//**************************************/
static void one_tempir_1_in_lsd(void){
	tempir_in_bcd(DS1,2,PWIRE1,true);//0-00.0 *c //inl
	grad_celsia();
	lcd_buffer[0]=font[f_y]|font[tochka];
}
//**************************************/
void clock_in_lcd1(void)
{
	num2_bcd_in_lcd(1,hour[H_HOUR]);
	blank_nul(1);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&hour[H_MIN]);
}
//**************************************
void timer_in_lcd(void)
{
uint8_t *p;
    if ( timer[3] & _BV(FL_TIMER_COUNT) ){
		lcd_buffer[0]=font[f_t];
		p=TimerTime;
		}
		else{
	 	lcd_buffer[0]=font[f_seg_d];
		p=timer;
		}
	
	num2_bcd_in_lcd(1,p[H_HOUR]);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&p[H_MIN]);
}
void num_month_year_constructor(uint8_t znmesto, uint8_t zn_year){
	
	lcd_buffer[zn_year]=font[2];
	lcd_buffer[zn_year+1]=font[0];
	num2_bcd_in_lcd(zn_year+2,hour[H_YEAR]);
	
	num2_bcd_in_lcd(znmesto,hour[H_NUM]+1);
	lcd_buffer[znmesto+1]|=font[tochka];
	num2_bcd_in_lcd(znmesto+2,hour[H_MONTH]+1);
	lcd_buffer[znmesto+3]|=font[tochka];
}

static void num_month_year(void){
	num_month_year_constructor(1,5);
}

static void num_month_year_day(void){
	num_month_year_constructor(0,2);
	day_str();
}

static void num_month_year_daynum(void){
	lcd_buffer[0]=font[hour[H_DAY]+1];
	num_month_year_constructor(2,4);
	lcd_buffer[8]=font[f_r]|font[tochka];
}

static void num_month_year_g(void){
	num_month_year_constructor(1,3);
	lcd_buffer[7]=font[f_r]|font[tochka];
}

static void sht_humidy(void){
	form_str(ShtHumi, 2,true, (FlagSht & FL_NO_SENSOR) );
	lcd_buffer[0]=font[f_H]|font[tochka];
	lcd_buffer[7]=font[f_gr];
	lcd_buffer[8]=font[f_o];
}
static void sht_humidy_temper(uint8_t t){
	form_str(ShtTemper, 4+t, 1-t, (FlagSht & FL_NO_SENSOR) );
	form_str(ShtHumi,   0,   1-t, (FlagSht & FL_NO_SENSOR) );
	lcd_buffer[8]=font[f_gr];
	if (t){
		//lcd_buffer[3]=font[f_gr];
		//lcd_buffer[4]=font[f_o];
		lcd_buffer[3]=font[f_seg_b]|font[f_seg_e];//|font[f_seg_c]
		//lcd_buffer[4]=font[f_seg_e];
		}
		else
		lcd_buffer[4]=font[f_seg_b]|font[f_seg_e];
}

//**************************************
static uint16_t usr_pressure(uint16_t *m, uint8_t usr){
uint32_t rez=0;
	for (uint8_t j=0; j<usr; j++) rez+=m[j];
	return rez/usr;
}

void trend_pressure(uint8_t mesto){
uint16_t minTime,maxTime;
	minTime=usr_pressure(pressure_massiv_min,USR_PRESS_MIN_TIME);
	maxTime=usr_pressure(pressure_massiv_max,USR_PRESS_MAX_TIME);
	if (minTime>maxTime) 
		lcd_buffer[mesto]=font[f_seg_a];
		else
		lcd_buffer[mesto]=font[f_seg_d];
}

static void bpm180_Pa(void){
uint32_t Pressure=Bmp180Pressure;
uint8_t dig=0;
	if ( FlagBMP180 & FL_BMP180_NO_SENSOR ){
		lcd_buffer[2]=font[f_seg_g];//1000
		lcd_buffer[3]=font[f_seg_g];//100
		lcd_buffer[4]=font[f_seg_g];//10
		}
	else
	{
	while (Pressure>=100000){
		Pressure-=100000;
		dig++;
		}
	if (dig)
		lcd_buffer[0]=font[dig];//100 000
	dig=0;
	while (Pressure>=10000){
		Pressure-=10000;
		dig++;
		}
	lcd_buffer[1]=font[dig];//10 000
	
	result_in_bcd( (int)Pressure); 
	lcd_buffer[2]=font[bcd_num1]|font[tochka];//1000
	lcd_buffer[3]=font[bcd_num2];//100
	lcd_buffer[4]=font[bcd_num3];//10
	lcd_buffer[5]=font[bcd_num4];//1
	}

	lcd_buffer[7]=font[f_P];
	lcd_buffer[8]=font[f_A];
	trend_pressure(6);
	
}

//0-	740.9_Ptut
//1-	 740.9 h
//2-	 740.9 dA8.
static void bpm180_PtStolb(uint8_t m){
uint8_t j=0;
	if (m==1) j=3;
	if (m==2) j=1;
	if ( FlagBMP180 & FL_BMP180_NO_SENSOR ){
		lcd_buffer[j]=font[f_seg_g];//1000
		lcd_buffer[j+1]=font[f_seg_g];//100
		lcd_buffer[j+2]=font[f_seg_g];//10
		}
	else
	{	result_in_bcd( (int)usr_pressure(pressure_massiv_min,USR_PRESS_MIN_TIME)); 
		lcd_buffer[j+0]=font[bcd_num1];//1000
		lcd_buffer[j+1]=font[bcd_num2];//100
		lcd_buffer[j+2]=font[bcd_num3]|font[tochka];//10
		lcd_buffer[j+3]=font[bcd_num4];//1
	}
	if (m==0){
		trend_pressure(4);
		lcd_buffer[5]=font[f_P];//1
		lcd_buffer[6]=font[f_t];
		lcd_buffer[7]=font[f_y];
		lcd_buffer[8]=font[f_t]|font[tochka];
		}
	else
	if (m==1){
		trend_pressure(1);
		lcd_buffer[3+3]=0;
		if ( bcd_num4 < 5 ) lcd_buffer[3+2]&=~font[tochka];
		lcd_buffer[8]=font[f_P];
		}
	if (m==2){
		trend_pressure(5);
		lcd_buffer[6]=font[f_d];//1
		lcd_buffer[7]=font[f_A];//1
		lcd_buffer[8]=font[8]|font[tochka];//1
		}
}
/*
static void bpm180_PtStolb(void){
	if ( FlagBMP180 & FL_BMP180_NO_SENSOR ){
		lcd_buffer[1]=font[f_seg_g];//1000
		lcd_buffer[2]=font[f_seg_g];//100
		lcd_buffer[3]=font[f_seg_g];//10
		}
	else
	{
		result_in_bcd( (int)usr_pressure(pressure_massiv_min,USR_PRESS_MIN_TIME)); 
		lcd_buffer[0]=font[bcd_num1];//1000
		lcd_buffer[1]=font[bcd_num2];//100
		lcd_buffer[2]=font[bcd_num3]|font[tochka];//10
		lcd_buffer[3]=font[bcd_num4];//1
	}
	trend_pressure(4);
	lcd_buffer[5]=font[f_P];//1
	lcd_buffer[6]=font[f_t];
	lcd_buffer[7]=font[f_y];
	lcd_buffer[8]=font[f_t]|font[tochka];
}
*/
static void bpm180_PtStolb_Temper(void){
	bpm180_PtStolb(0);
	lcd_buffer[7]=font[f_seg_g];
	form_str(Bmp180Temper, 4, 1, FlagBMP180 & FL_BMP180_NO_SENSOR );
	lcd_buffer[8]=font[f_gr];
}

//*************************************
void power_in_lcd(unsigned char pin_wire, unsigned char mesto){
unsigned char a,b;
	if ( !(pin_wire & out_1wire) ){
		a=font[f_seg_g];
		b=font[f_seg_g];
		}
		else
		if (power_suplly_1w & pin_wire )
		{
		a=font[f_P];
		b=font[f_A];	
		}
		else{
		a=font[f_o];
		b=font[f_n];
		}
	lcd_buffer[mesto]=a;
	lcd_buffer[mesto+1]=b;
}


void view_in_indikator(unsigned char view){
  switch (view)
  {
    //case (0): sht_humidy(); 		break;//num,day, hour-min
    case (0): clock_in_lcd0(); 			break;//num,day, hour-min
    case (1): clock_in_lcd1();			break;//hour-min-sek
	case (2): clock_in_lcd_gl(2);		break;//hour-min
	case (3): clock_day_str();			break;//hour-min day
	case (4): tempir_1_clock_in_lcd();	break;// tempir0 hour-min
	case (5): tempir_2_clock_in_lcd();	break;// tempir1 hour-min
	case (6): one_tempir_0_in_lsd();	break;// _ -000 *C 1
	case (7): one_tempir_1_in_lsd();	break;// _ -000 *C 2
	case (8): tempir_2oo_in_lcd();		break;//00*  00*
	case (9): tempir_2o_in_lcd();		break;// 00.0 o 00.0
	case (10): tempir_2_in_lcd(true);	break;// -00 -00//
	case (11): sht_humidy();			break;//H  70.1 %
	case (12): sht_humidy_temper(0);	break;// 70.1% 25.3`
	case (13): sht_humidy_temper(1);	break;// 70.%  25.`
	case (14): bpm180_Pa();				break;// 095350 Pa;// 101 325   760   
	case (15): bpm180_PtStolb(0);		break;// 760 Ptyt;// 101 325   760   
	case (16): bpm180_PtStolb(1);		break;// 760.0_h
	case (17): bpm180_PtStolb(2);		break;// 760.0_dA8 
	case (18): bpm180_PtStolb_Temper();	break;// 760.0 25.0
	case (19): num_month_day();			break;//num_month day
	case (20): num_month_year();		break;//31.12.2008
	case (21): num_month_year_day();	break;//31.12.08 CP
	case (22): num_month_year_daynum();	break;//5 19.12.08.
    default: num_month_year_g();      	break;//19.12.08.
  }
}

static void indikator_manager(void){
unsigned char i, a;

	a=i=current_state_view.regim;	//  
	if ( ++i>=Count_regim ) i=0; //     ,  a.
	
	while ( i!=a )
		{
		if (current_state_view.regim==a)
			{
			if  (setup.state_time[i] > 0)
				{
				if (current_state_view.skip[i]) //   , 
					current_state_view.skip[i]--;//   	 
					else
					{
					current_state_view.regim=i;
					break;
					}
				}
			}
		if ( ++i>=Count_regim ) i=0;
		}
	
	i=current_state_view.regim;
	//if (i==a) 
	//i=0;//    ,    = 0
	current_state_view.time=		setup.state_time[i];
	current_state_view.skip[i]=		setup.state_skip[i];
	current_state_view.viewstate=	setup.state_regim[i];
}


void num3_th_in_lcd_buffer(unsigned char m){
	lcd_buffer[m]	=font[bcd_num2];
	lcd_buffer[m+1]	=font[bcd_num3];
	lcd_buffer[m+2]	=font[bcd_num4]|font[tochka];
}

//**************************************/
static void data_lcd(void)
{
static uint8_t state_view_init=0;
 	cls_lcd_buffer();
//return;	
	if (regim==0){
		if ( state_view_init ){
			state_view_init=0;
			current_state_view.viewstate= 0;
			current_state_view.time = 2;
			for(uint8_t i=0; i<Count_regim; i++)
					current_state_view.skip[i]=0;
			}
		if (eeprom_err){
			lcd_buffer[3]=font[f_E];
			lcd_buffer[4]=font[f_E];
			lcd_buffer[5]=font[f_P];
			}
			else
			{
			view_in_indikator(current_state_view.viewstate);
			}
		if (time_flag & FL_SIG_OTSR)  
			if (! (time_flag & FL_SEK_1_SWITCH) ) 
						lcd_buffer[8]|=font[tochka];
		return;
		}
		else{
		state_view_init=1;
		}
	
	if (regim==100){//       
		clock_in_lcd0();//    
		
		if (time_flag & FL_SIG_OTSR) lcd_buffer[3]=font[f_o];//if (time_flag & _BV(fl_otsrochka_signala)) 
		return;
		}
	
	if  (regim==3) {timer_in_lcd(); return;}
	
	if (regim==REG_BUDILNIK){//calls
		load_str_in_lcdbuffer1((prog_int8_t*)&str_calls);//
		return;
	    }
	if  (regim==REG_SETUP){//setup
		load_str_in_lcdbuffer1((prog_int8_t*)&str_setup[0]);
		return;
		}//*/
	if  (regim==REG_TIMER){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_timmer[0]);
		return;
		}
	
	// 
	if  (regim==REG_LIGHT){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_light[0]);
		return;
		}
	//light	
	if  (regim==11){
		//lcd_buffer[0]=font[f_L];
		if (setup.day_light>=sizeof(light_disp)-1) setup.day_light=sizeof(light_disp)-1;
	    //for(uint8_t i=0; i<setup.day_light; i++)
		//	lcd_buffer[i+1]=font[f_o];
		load_str_in_lcdbuffer1((prog_int8_t*)&str_light_day[0]);
		lcd_buffer[7]=font[setup.day_light];
		lcd_light=setup.day_light;
		return;
		}
	if  (regim==14){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_light_noch[0]);
		lcd_buffer[7]=font[setup.night_light];
		lcd_light=setup.night_light;
		return;
		}// end light
	if  ( (regim>14)&&(regim<17) ){
		lcd_buffer[1]=font[f_c];
		num2_bcd_in_lcd(2,setup.tim_c_light);
		lcd_buffer[5]=font[f_d];
		lcd_buffer[6]=font[f_o];
		num2_bcd_in_lcd(7,setup.tim_do_light);
		return;
		}// end light
	
	
	//----------------------------
	if (regim==REG_CLOCK){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_clock[0]);
		return;
	    }
	if ( ( regim>=r_clock )&&( regim<=r_clock+2 ) ){
		clock_in_lcd1();//hour-min-sek  
		return;
	    }
	if ( ( regim>=r_clock+3 )&&( regim<=r_clock+6 ) ){
		num_month_year_day();
		return;
	   	}

	if ( ( regim>=r_clock+7 )&&( regim<=r_clock+8 ) ){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_corr[0]);
		if ( setup.corr_flag&_BV(FL_CORR_ZNAK_PL) ) lcd_buffer[4]=font[f_seg_d]; 
	   	  else 							   	 lcd_buffer[4]=font[f_seg_g];   
		lcd_buffer[5]=font[n0]|font[tochka];

		result_in_bcd( pgm_read_word_near(&corr_in_lcd[setup.correction]) );
		lcd_buffer[6]	=font[bcd_num2];
		lcd_buffer[7]	=font[bcd_num3];
		lcd_buffer[8]	=font[bcd_num4];
		return;
		}	

	// 
	if ((regim>30)&&(regim<35)){
	   	lcd_buffer[0]=font[budilnik_nomer];
		lcd_hh_mm(&setup.budilnik[ budilnik_nomer ] [C_HOUR]);
		lcd_buffer[1]=sig_bud_str[ setup.budilnik[ budilnik_nomer ][C_SIG] ][0];
		lcd_buffer[2]=sig_bud_str[ setup.budilnik[ budilnik_nomer ][C_SIG] ][1];
		if (( budilnik_nomer >= 8 )&&( budilnik_nomer <= 9 )) {if (!nedelia[budilnik_nomer-8]) lcd_buffer[3]=font[f_gr]; else lcd_buffer[3]=font[f_seg_d];}
		return;
		}	
	if ((regim>44)&&(regim<48)){
		num2_bcd_in_lcd(1,setup.budil_pin[budilnik_nomer-10][H_HOUR]);
		lcd_buffer[3]=font[f_seg_g];
		lcd_hh_mm(&setup.budil_pin[budilnik_nomer-10][H_MIN]);
		return;
		}	
	if ((regim>34)&&(regim<42)){
	    lcd_buffer[0]=font[f_d]|font[tochka];
		for (uint8_t i=0; i<7; i++){
			if ((setup.budilnik[ budilnik_nomer ][C_DAY])&_BV(i))
			lcd_buffer[i+2]=font[i+1]; else lcd_buffer[i+2]=font[f_seg_d];
			}
		return;
		}
	//--SIGNAL--
	if (regim==REG_SIGNAL){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_signal[0]);
		return;
	    }
	if (regim==reg_signal){
		if (p_index==0)	load_str_in_lcdbuffer1((prog_int8_t*)&str_budil[0]); 
		else				load_str_in_lcdbuffer1((prog_int8_t*)&str_button[0]);	
		lcd_buffer[8]=font[f_S];
		return;
		}
	if ((regim>reg_signal)&&(regim<reg_signal+3)){
		
		if ( p_index == 0 ){
			signal=SIG_ON;
			time_signal=10;
			time_flag|= FL_SIGNAL_OUT_ENABLE;
			}
		
		lcd_buffer[0]=font[f_H];
		result_in_bcd(setup.ocr1[p_index*2]);
		num3_th_in_lcd_buffer(1);
		lcd_buffer[5]=font[f_L];
		result_in_bcd(setup.ocr1[p_index*2+1]);
		num3_th_in_lcd_buffer(6);
		return;
		}
	//--END--SIGNAL--

	//   
	if (regim==REG_SBROS_N){// 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_default[0]);
		return;
	    }
	// 
	if (regim==REG_PORT){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_port[0]);
		return;
	    }
	if ( regim==71 ){//
		load_str_in_lcdbuffer1((prog_int8_t*)&str_pin_c[0]);
		if ( ACTIVE(CALLS_NAGRUZ) ) lcd_buffer[5]=font[1]; else lcd_buffer[5]=font[0];
		return;
	   	}
	//===============================
	if ( regim==REG_YST_BUD ){//  _yct_bud_ 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_yst_bud[0]);
		return;
	    }
	if (regim==75){ //CAL. bIP C 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_sig_budil[0]);
		
		uint8_t *p;
		p=(uint8_t*)yst_bud_str+setup.signal_bud*3;

		lcd_buffer[6]=*p;
		lcd_buffer[7]=*(p+1);
		lcd_buffer[8]=*(p+2);
		
		//lcd_buffer[6]=yst_bud_str[setup.signal_bud][0];
		//lcd_buffer[7]=yst_bud_str[setup.signal_bud][1];
		//lcd_buffer[8]=yst_bud_str[setup.signal_bud][2];
		return;
	    }
	
		
	if 	((regim>79)&&(regim<84)) {timer_in_lcd(); return;}
	
	if (regim==REG_YST_SEE){//t see	
	    load_str_in_lcdbuffer1((prog_int8_t*)&str_yst_see[0]);
		return;
	    }
	
	//if ((regim>90)&&(regim<95)) {
	if ( (regim==91)||(regim==93)||(regim==94)) {

		lcd_buffer[0]=font[current_state_view.regim+1];
		lcd_buffer[1]=font[f_r];//|font[tochka];
		lcd_buffer[2]=font[setup.state_regim[current_state_view.regim] ];//|font[tochka];
		lcd_buffer[4]=font[f_c];
		num2_bcd_in_lcd(5,setup.state_time [current_state_view.regim]);
		
		lcd_buffer[7]=font[f_n];//|font[tochka];
		lcd_buffer[8]=font[setup.state_skip [current_state_view.regim] ];//|font[tochka];
		
		//lcd_buffer[8]^=font[tochka];

		return;
		}
		
	if (regim==92){//  
		view_in_indikator(setup.state_regim[current_state_view.regim]);
		return;
		}
	
	if (regim==REG_DS18B20){//d, S, 1, 8, b, 2, 0, 
		load_str_in_lcdbuffer1((prog_int8_t*)&str_ds18b20[0]);
		return;
		}
	if (regim==111){// on on
		if (setup.vid_t==0) 
			load_str_in_lcdbuffer1((prog_int8_t*)&str_vid1_t[0]);
			else
			load_str_in_lcdbuffer1((prog_int8_t*)&str_vid2_t[0]);
		//load_str_in_lcdbuffer1((prog_int8_t*)&str_pit[0]);
		//power_in_lcd(PWIRE0, 4);
		//power_in_lcd(PWIRE1, 7);
		return;
		}
	if ((regim>111)&&(regim<114)){
		if (p_index)
			form_str(setup.corrDs[1],5, 1, 0 );
			else
			form_str(setup.corrDs[0],5, 1, 0 );
		
		lcd_buffer[0]=font[f_c];//|font[tochka];
		lcd_buffer[1]=font[f_o];//|font[tochka];
		lcd_buffer[2]=font[f_r];
		lcd_buffer[3]=font[f_r]|font[tochka];
		lcd_buffer[4]=font[p_index+1];//|font[tochka];
		}
		
	if (regim==114){
		load_str_in_lcdbuffer1((prog_int8_t*)&str_pit[0]);
		power_in_lcd(PWIRE0, 4);
		power_in_lcd(PWIRE1, 7);
		return;
		}

	//-------------BMP180------------------
	if (regim==REG_BMP180) {//126
		load_str_in_lcdbuffer1((prog_int8_t*)&str_pressure[0]);
		return; 
		}
	if (regim==120) {
		load_str_in_lcdbuffer1((prog_int8_t*)&str_init_p[0]);
		return;
		}
	//-----------------------------------------

	if (regim==REG_SAVE_SETUP) {
		load_str_in_lcdbuffer1((prog_int8_t*)&str_save_eeprom[0]);
		return;
		}
	
	if (regim==150){// 
		if (time[BEG_STR]<=0){
			time[BEG_STR]=45;
			simvol++;
			if (simvol==str_length+9) simvol=0;
			}
		for (uint8_t a=0, i=simvol; a<9 ; i++, a++){
				if ( (i>8)&&(i<str_length+9) )
					lcd_buffer[a]=*(ukaz_na_str+i-9);//str[i-9];
			}
		}
}
//**************************************
static void str_init(void){
unsigned char h;
	//0-5; 6-11; 12-17; 18-23;
	
	h=hour[H_HOUR];
	if (h<6)	ukaz_na_str=&str_noch[0];	else
	if (h<12)	ukaz_na_str=&str_utro[0];	else
	if (h<18)	ukaz_na_str=&str_day[0];	else
				ukaz_na_str=&str_vecher[0];

	*(ukaz_na_str+5)=font[budilnik_nomer];
	result_in_bcd(hour[H_HOUR]);
	*(ukaz_na_str+7)=font[bcd_num3];
	*(ukaz_na_str+8)=font[bcd_num4];
	result_in_bcd(hour[H_MIN]);
	*(ukaz_na_str+10)=font[bcd_num3];
	*(ukaz_na_str+11)=font[bcd_num4];
}

//**************************************
void init_signal(void){
	str_init();
	count_note=0;
	simvol=0;
	time[NOTE]=3;
	time_signal=59;
	time_in_regim=59;
	time_flag &=~  FL_SIGNAL_CLS;
	time_flag |=   FL_SIGNAL_OUT_ENABLE;
}

void shim(void){
unsigned char tmp;
	if (time[NOTE]<=0)
		{
		tmp=uprav_TCCR1B[count_note];
		if (tmp&0x01)	timer1_init_in_pwm();
			else		timer1_init();
		time[NOTE]=length_note[count_note];
		TCCR1B=tmp;
		if (++count_note==4) count_note=0;
		}
}

static void budilnik_out(void){
if (!setup.signal_bud){
	shim();
	}
	else 
	if (setup.signal_bud==1){
		ON(CALLS_OSN);	
		}
	else{
	shim();
	ON(CALLS_OSN);
	}
}
//*************************************
static void signal_off(void)
{
//   ---------------------------
	if ( time_signal==0 )
	{	
		if (signal==0) //   
		{
		if (time_flag & FL_SIG_OTSR) //   
			{
			if ( ++budilnik_play_num==8 ) {//  .  7 , //
				time_flag &= ~FL_SIG_OTSR;
				}
				else{//   ,   ,   
				init_signal();
				regim=150;
				signal=SIG_ON_OTSR;
				return;//   
				}
			}
		}
		else
		if (signal<SIG_FOREVER) time_flag |= FL_SIGNAL_CLS;
	}

//  
	if ( !(time_flag & FL_SIG_BUTT) )
	if ( time_flag & FL_SIGNAL_CLS )//  
		{
		time_flag &=~  (FL_SIGNAL_CLS|FL_SIGNAL_OUT_ENABLE);
			
		OFF(CALLS_OSN);
		OFF(TIMER_PIN);
		timer1_init();
		
		time_signal=0xFF;	
		
		if (signal==SIG_ODINRAZ) setup.budilnik[budilnik_nomer][C_SIG]=0;
			
		signal=0;
		}
}

//*************************************


//**************************************/
static void calls_verify(void)
{
unsigned char i;
	for(i=0;i<12;i++)
		if ( setup.budilnik[i][C_SIG] )//  
		  if ( _BV(hour[H_DAY])&setup.budilnik[i][C_DAY] )// 
		   	if (setup.budilnik[i][C_HOUR]==hour[H_HOUR])//
			  if (setup.budilnik[i][C_MIN]==hour[H_MIN])//
				{
				if (i<8){
					budilnik_nomer=i;
					signal=setup.budilnik[i][C_SIG];
					if (signal==SIG_ON_OTSR ) time_flag |= FL_SIG_OTSR;
					budilnik_play_num=0;//           
					init_signal();
					regim=150;
					} 
					else
				if (i<10){
					if ( (nedelia[i-8] & _BV(0))==0 ){
						budilnik_nomer=i;
						signal=setup.budilnik[i][C_SIG];
						if (signal==SIG_ON_OTSR ) time_flag |= FL_SIG_OTSR;
						budilnik_play_num=0;//           
						init_signal();
						regim=150;
						}
					}
					else{//  

					uint8_t c=i-10;
					time_bud_pin=(uint16_t)setup.budil_pin[c][H_HOUR]*3600+setup.budil_pin[c][H_MIN]*60+setup.budil_pin[c][H_SEK];
					if (time_bud_pin){
						time_flag|=FL_CALLS_PIN_A_ON;
						ON(CALLS_NAGRUZ);
						}
					}
				}
}
//**************************************
static void calls_pin_verify(void){

	if ( time_flag & FL_CALLS_PIN_A_ON )
	{
	if (--time_bud_pin==0xFFFF)
		{
		OFF(CALLS_NAGRUZ);
		time_flag &=~ FL_CALLS_PIN_A_ON;
		}
	}
}
//*/
//**************************************
static void timer_verify(void){
	if (timer[3]&_BV(FL_TIMER_COUNT) )//yst bit 0 dlia schet enable
	{
	if		(!TimerTime[H_HOUR])
	 if 	(!TimerTime[H_MIN])
	  if	(!TimerTime[H_SEK])	
		{
		timer[3]&=~_BV(FL_TIMER_COUNT) ;
		signal = SIG_TIMER;
		regim=80;
		init_signal();	
		ON(TIMER_PIN);
		return;
		}
	if ( --TimerTime[H_SEK]<0 ){
	  	TimerTime[H_SEK]=59;
		TimerTime[H_MIN]--;
		if ( TimerTime[H_MIN]<0 ){
		 	TimerTime[H_MIN]=59;
			TimerTime[H_HOUR]--;
			}
		}
	}
}
//**************************************
/*/--------------------
int UpdateAverage( int CurrVal )
{
static int Sum = 0;
int tmp = (Sum + (16 >> 1)) >> 4; //  = (Sum + n/2) / n,  n = 16
Sum += CurrVal - tmp;
return tmp;
}
//--------------------*/


//**************************************
static void clock(void){
static uint8_t j=0, i=0;
  if ( isr_1sek_ )// 
	{
	correct=0;
	if (++hour[H_SEK]>=60)
		{
		if (++hour[H_MIN]>=60)
			{
			if ( setup.corr_flag&_BV(FL_CORR_ZNAK_PL) )// 
				correct=setup.correction;// 
				else
				correct= 0x00-setup.correction;
			
			hour[H_MIN] =0;
			hour[H_HOUR]++;
		
			if (hour[H_HOUR]>=24)
				{
				hour[H_HOUR]=0;
				hour[H_DAY]++;
				hour[H_NUM]++;
				if (hour[H_DAY]>=7)	{hour[H_DAY]=0; nedelia[0]^=_BV(0);nedelia[1]^=_BV(0);}
				if (hour[H_NUM]>=num_in_month[hour[H_MONTH]] )////!!!if (hour[H_NUM]> (num_in_month[hour[H_MONTH]]-1 ) )////!!!
					{
					hour[H_NUM]=0;
					hour[H_MONTH]++;
					if (hour[H_MONTH]>=12) 	{hour[H_MONTH]=0; hour[H_YEAR]++;}
					}
				}
			if ( hour[H_HOUR] == setup.tim_c_light)	lcd_light=setup.night_light;
			if ( hour[H_HOUR] == setup.tim_do_light)	lcd_light=setup.day_light;
			
			/*/ / 
			//           2:00     1  
			//          3:00    1  .
			if ( hour[H_DAY]==7-1 )// 
				if ( hour[H_NUM]>24-1 )//  25  
					if ( hour[H_MONTH]==3-1 ){//  
						if (hour[H_HOUR]==2) hour[H_HOUR]=3;
				}
			if ( hour[H_MONTH]==10-1 )
				{//  
				if ( hour[H_NUM]>24-1 )//  25  
					if ( hour[H_DAY]==7-1 )// 
						if (hour[H_HOUR]==3) 
							{
							static uint8_t zimnie=0;
							if (zimnie==0){
								zimnie=1;
								hour[H_HOUR]=2;
								}
								else
								zimnie=0;
							}
				}
			*/
			
			pressure_massiv_max[i & (USR_PRESS_MAX_TIME-1)]=usr_pressure(pressure_massiv_min,USR_PRESS_MIN_TIME);//  1       
			i++;
			}
		hour[H_SEK] =0;
		calls_verify();
		}
	pressure_massiv_min[j & (USR_PRESS_MIN_TIME-1)]=Rt_mm;//     
	//pressure_massiv_min[j & (USR_PRESS_MIN_TIME-1)]=7405;//     
	j++;
	isr_1sek_=0;
	}
}
//****************************************

void time_direct(void){
static unsigned char t, sek;

	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;
		
		if (t>=64) time_flag|=FL_SEK_1_SWITCH; else time_flag&=~FL_SEK_1_SWITCH;
		for ( uint8_t i=0; i<4; i++) time[i]--;
		
		if ( time_flag & FL_SIG_BUTT )
			if (time[NOTE_BUT]<0)
			{
			time_flag&= ~ FL_SIG_BUTT;
			timer1_init();
			}
	
		if ( sek!=hour[H_SEK] ){// 
			sek=hour[H_SEK];
			if (regim==0)
				if (--current_state_view.time == 0 ) indikator_manager();
			if (--time_in_regim == 0 )
						if (regim>=4) regim=0;
			time_signal--;
			timer_verify();
			calls_pin_verify();// 
			
			TimeMeasureDs18B20--;
			}

		//  
		signal_off();
		if (time_flag&FL_SIGNAL_OUT_ENABLE) budilnik_out();//       
		
		if (time_flag&FL_POWER_INIT_DEVICE)//   
			skankey();
		
		if (regim>=4)//if (mask)
			{
			static uint8_t time_mig=0;
			if (++time_mig>=light_time_mig[lcd_light])//(10-lcd_light)
				{
				time_mig=0;
				change_light_var();
				}
			}
		}
}
//---------------------------------------------------------
static void init_devices_save_mode(void)
{
	TIMSK0=0;
	OFF(STORAGE);// 
	OFF(DATA_595);// 
	OFF(SHIFT);// 
	//OFF(DATA);
	//OFF(SCK);
	pullup_off();
	
}
//---------------------------------------------------------


int main(void)
{
uint8_t TrigTimeI2C=0;
	cli();
	read_data_EEPROM();
	
	timer2_init();
	init_devices();

while(1)
 {//while

   clock();
   if ( ACTIVE(EXT_POWER) )
	{//begin power on
	 	if ( time_flag & FL_POWER_INIT_DEVICE )
			{
			time_flag &= ~FL_POWER_INIT_DEVICE;
			PRR=_BV(PRTWI)|_BV(PRSPI)|_BV(PRUSART0)|_BV(PRADC);
			init_devices();
			current_state_view.time=2;
			time_in_regim=2;
			}
		/* */  
		
		if (lcd_time_switch>=58)/* 2msek*/ 
	  	   	{
			ON(STORAGE);//. 
			//lcd_time_switch=0x00;
			
  	   		if  (++znakomesto<9) {
			
				num_out();//    ,   
				lcd_time_switch=0x00;
				light_isr=light_disp[opred_light_current_num()];// 

				skankey();
				key_action();
				}
				else	
				{
//				PORTID|=pin_id; //  	

				if (regim){
					uint8_t l=setup.day_light;
					if ( setup.tim_do_light > setup.tim_c_light )
						{
						if ( (hour[H_HOUR] < setup.tim_do_light )&&( hour[H_HOUR] >= setup.tim_c_light ) ) 
							l=setup.night_light; else l=setup.day_light;
						}
						else
						{
						if ( (hour[H_HOUR] >= setup.tim_do_light )&&( hour[H_HOUR] < setup.tim_c_light ) ) 
							l=setup.day_light; else l=setup.night_light;
						}
					lcd_light=l;
					}
				lcd_time_switch=55;
				data_lcd();
				znakomesto=0xFF;
				}
	  		TrigTimeI2C=1;
			}
		time_direct();
		
		if (lcd_time_switch<5){ 
			izmerenie_t();	/* e*/
			if ( ((count_com_1w==4)||(out_1wire==0)) && TrigTimeI2C ){//      2
				TrigTimeI2C=0;
				//------------------------------------------------------------------------------
				if ( (FlagSht & (FL_MEASURE_END|FL_SHT_ERR))==0 ) {
					measure_sht21();
					} 
				else
				if ((FlagBMP180 & (FL_BMP180_MEASURE_END|FL_BMP180_ERROR))==0){
					measure_bmp180();
					}
				else{
					FlagSht &= ~(FL_MEASURE_END|FL_SHT_ERR);
					FlagBMP180 &= ~(FL_BMP180_MEASURE_END|FL_BMP180_ERROR);
					}

				//------------------------------------------------------------------------------
				}
			}
		
	}//end power on
	 else
	{//begin power off
	if (!(time_flag&FL_POWER_INIT_DEVICE))
		{
		time_flag|=FL_POWER_INIT_DEVICE;
		init_devices_save_mode();
		}
	
	time_flag &= ~FL_SIG_OTSR;//    
	
	if ( signal || ( time_flag & FL_SIG_BUTT ) )//          
		{
		time_direct();
		if (key!=17){
			time_flag |=  FL_SIGNAL_CLS;
			time_flag &= ~FL_SIGNAL_OUT_ENABLE;
			//if (F_) time_flag &= ~FL_SIG_OTSR;
			}
		}
		else
		{//        
		//MCUCR = _BV(SM1)|_BV(SM0)|_BV(SE);
		//PRR=_BV(PRTWI)|_BV(PRTIM0)|_BV(PRTIM1)|_BV(PRSPI)|_BV(PRUSART0)|_BV(PRADC);
		OCR2A=1;
		PRR=_BV(PRTWI)|_BV(PRTIM0)|_BV(PRTIM1)|_BV(PRSPI)|_BV(PRUSART0)|_BV(PRADC);
		while(ASSR & _BV(OCR2AUB));
		
		//while(ASSR & (1<<TCN2UB)); //wait to TCNT update!!! 
		SMCR = _BV(SM1)|_BV(SM0)|_BV(SE);
		asm("sleep");
		SMCR=0;

		}
	}//end power off
 }//while

}
