#include <avr/io.h>
#include <util/delay.h>

#include "i2cSoft.h"
	


void i2c_Init (void);
uint8_t i2c_Start(void);
uint8_t i2c_Stop(void);
uint8_t i2c_wr_byte(uint8_t Byte);
uint8_t i2c_rx_byte(uint8_t Ask); 

void i2c_Init (void){
	OFF(SCL);
	OFF(SDA);
	SCL_UP;
	SDA_UP;
}

uint8_t i2c_Start(void){
	if (ACTIVE(SDA)==0) return 1;
	if (ACTIVE(SCL)==0) return 1;
	SCL_UP;
	SDA_UP;
	SDA_DOWN;
	_delay_us(10);
	SCL_DOWN;
	_delay_us(10);
	return 0;
}

uint8_t i2c_Stop(void){
uint8_t error=0;
	SDA_DOWN;
	SCL_DOWN;
	SCL_UP;
	_delay_us(10);
	if (ACTIVE(SCL)==0) error=1;
	SDA_UP;
	_delay_us(10);
	if (ACTIVE(SDA)==0) error=1;
	return error;
}

uint8_t i2c_wr_byte(uint8_t Byte){
	
	for(uint8_t b=_BV(7); b; b>>=1){
		if (Byte & b) SDA_UP; else SDA_DOWN;
		_delay_us(1);
		SCL_UP;
		_delay_us(5);
		SCL_DOWN;
		_delay_us(3);
		}
	SDA_UP;	
	//----ASK----
	uint8_t Ask=0;
	SCL_UP;
	_delay_us(3);
	if (ACTIVE(SDA)) Ask=1;//   
	SCL_DOWN;
	return Ask;
}

uint8_t i2c_rx_byte(uint8_t Ask){
uint8_t Val=0;
	
	for(uint8_t b=_BV(7); b; b>>=1){
		SCL_UP;
		_delay_us(3);
		if (ACTIVE(SDA))	Val|=b;
		SCL_DOWN;
		_delay_us(3);
		}
	
	if (Ask) SDA_DOWN;
	SCL_UP;
	_delay_us(5);
	SCL_DOWN;
	SDA_UP;
	return Val;
}

