#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*The maximal possible delay is 262.14 ms/F_CPU in MHz. Delay is 768us/F_CPU_in_MHz.*/
//#include <stdlib.h>	
//#include <math.h>	

// sensor command
typedef enum{
  TRIG_T_MEASUREMENT_HM    = 0xE3, // command trig. temp meas. hold master
  TRIG_RH_MEASUREMENT_HM   = 0xE5, // command trig. humidity meas. hold master
  TRIG_T_MEASUREMENT_POLL  = 0xF3, // command trig. temp meas. no hold master
  TRIG_RH_MEASUREMENT_POLL = 0xF5, // command trig. humidity meas. no hold master
  USER_REG_W               = 0xE6, // command writing user register
  USER_REG_R               = 0xE7, // command reading user register
  SOFT_RESET               = 0xFE  // command soft reset
}etSHT2xCommand;

typedef enum {
  SHT2x_RES_12_14BIT       = 0x00, // RH=12bit, T=14bit
  SHT2x_RES_8_12BIT        = 0x01, // RH= 8bit, T=12bit
  SHT2x_RES_10_13BIT       = 0x80, // RH=10bit, T=13bit
  SHT2x_RES_11_11BIT       = 0x81, // RH=11bit, T=11bit
  SHT2x_RES_MASK           = 0x81  // Mask for res. bits (7,0) in user reg.
} etSHT2xResolution;

typedef enum {
  SHT2x_EOB_ON             = 0x40, // end of battery
  SHT2x_EOB_MASK           = 0x40, // Mask for EOB bit(6) in user reg.
} etSHT2xEob;

typedef enum {
  SHT2x_HEATER_ON          = 0x04, // heater on
  SHT2x_HEATER_OFF         = 0x00, // heater off
  SHT2x_HEATER_MASK        = 0x04, // Mask for Heater bit(2) in user reg.
} etSHT2xHeater;

typedef enum{
  I2C_ADR_W                = 0x80,	//128,   // sensor I2C address + write bit 
  I2C_ADR_R                = 0x81	//129    // sensor I2C address + read bit  
}etI2cHeader;



extern uint16_t ShtHumi;
extern int16_t ShtTemper;

extern uint8_t FlagSht;
//      !    .
#define FL_HM_REC		_BV(0) // 
#define FL_T_REC		_BV(1)
#define FL_T_MEASURE	_BV(2) //   
#define FL_NO_SENSOR	_BV(3) //  -      
#define FL_T_CRC_ERR	_BV(4)
#define FL_HM_CRC_ERR	_BV(5)
#define FL_MEASURE_END	_BV(6) // 
#define FL_SHT_ERR		_BV(7) //  ,   ,   

extern void measure_sht21(void);






